diff --git a/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java b/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java
index 79b4fe822..ec3aeb0fe 100644
--- a/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java
+++ b/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java
@@ -3,15 +3,17 @@ package net.minecraft.client.render.tessellator;
 import java.nio.ByteBuffer;
 import java.nio.ByteOrder;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.terrain.VertexConfig;
 import net.minecraft.client.render.terrain.VertexData;
 import net.minecraft.core.util.helper.MathHelper;
+import org.slf4j.Logger;
 
 public class TessellatorStandard extends TessellatorBase {
-
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public VertexData data;
 	public boolean drawing;
-	
+
 	private int color;
 	
 	private int lightmapCoord;
@@ -79,7 +81,7 @@ public class TessellatorStandard extends TessellatorBase {
 		if(data.buffer.capacity() < data.buffer.position() + 64) {
 			int newSize = data.buffer.capacity() * 2;
 			
-			System.out.println("Expanding Tessellator Buffer (" + data.buffer.capacity() + " -> " + newSize + ")");
+			LOGGER.info("Expanding Tessellator Buffer (" + data.buffer.capacity() + " -> " + newSize + ")");
 			
 			ByteBuffer newBuffer = ByteBuffer.allocateDirect(newSize).order(ByteOrder.nativeOrder());
 			data.buffer.flip();
diff --git a/src/main/java/net/minecraft/client/render/texture/FileTexture.java b/src/main/java/net/minecraft/client/render/texture/FileTexture.java
index 4922c53e3..1557368bf 100644
--- a/src/main/java/net/minecraft/client/render/texture/FileTexture.java
+++ b/src/main/java/net/minecraft/client/render/texture/FileTexture.java
@@ -1,9 +1,11 @@
 package net.minecraft.client.render.texture;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texture.meta.TextureMetaHandler;
 import net.minecraft.client.render.texturepack.TexturePack;
 import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
 import java.io.IOException;
 import java.io.InputStream;
@@ -12,7 +14,7 @@ import static net.minecraft.client.util.helper.Textures.missingTexture;
 import static net.minecraft.client.util.helper.Textures.readImage;
 
 public class FileTexture extends Texture{
-
+    private static final Logger LOGGER = LogUtils.getLogger();
     protected final String sourcePath;
 
     protected TextureMetaHandler metaHandler = new TextureMetaHandler();
@@ -59,7 +61,7 @@ public class FileTexture extends Texture{
                     metaHandler.loadFromStream(stream);
                 }
             } catch (Exception e) {
-                e.printStackTrace();
+                LOGGER.error("Failed to load data for '{}.mcmeta'!", sourcePath, e);
             }
 
             try (InputStream imageStream = pack.getResourceAsStream(sourcePath)) {
@@ -76,10 +78,8 @@ public class FileTexture extends Texture{
 
     @Override
     public String toString() {
-        StringBuilder builder = new StringBuilder();
-        builder.append("Source: ").append(sourcePath).append("\n");
-        builder.append("Meta: \n").append(metaHandler);
-        return builder.toString();
+        return "Source: " + sourcePath + "\n" +
+                "Meta: \n" + metaHandler;
     }
 
 }
diff --git a/src/main/java/net/minecraft/client/render/texture/Texture.java b/src/main/java/net/minecraft/client/render/texture/Texture.java
index 86b753d83..35453be3f 100644
--- a/src/main/java/net/minecraft/client/render/texture/Texture.java
+++ b/src/main/java/net/minecraft/client/render/texture/Texture.java
@@ -4,17 +4,20 @@ import static net.minecraft.core.util.helper.Buffer.buffer;
 import static org.lwjgl.opengl.GL11.*;
 import static org.lwjgl.opengl.GL12.GL_TEXTURE_MAX_LEVEL;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.enums.MipmapType;
 import net.minecraft.client.render.texture.meta.TextureProperties;
 import net.minecraft.core.util.helper.Buffer;
 import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
 import java.awt.image.BufferedImage;
 import java.nio.ByteBuffer;
 
 public class Texture {
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public static boolean debugMipmap = false;
 	protected static final boolean fixArtifacts = true;
 	
@@ -141,7 +144,7 @@ public class Texture {
 	}
 
 	protected void generateMipmaps(ByteBuffer buffer, BufferedImage image, int levels, boolean smooth) {
-		System.out.println("Generating Mipmaps...");
+		LOGGER.info("Generating Mipmaps...");
 
 		final int width = image.getWidth();
 		final int height = image.getHeight();
diff --git a/src/main/java/net/minecraft/client/render/texture/meta/TextureMetaHandler.java b/src/main/java/net/minecraft/client/render/texture/meta/TextureMetaHandler.java
index a679a2b34..d65097a7c 100644
--- a/src/main/java/net/minecraft/client/render/texture/meta/TextureMetaHandler.java
+++ b/src/main/java/net/minecraft/client/render/texture/meta/TextureMetaHandler.java
@@ -6,16 +6,19 @@ import com.google.gson.GsonBuilder;
 import com.google.gson.JsonObject;
 import com.google.gson.JsonParseException;
 import com.google.gson.JsonParser;
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.texture.meta.gui.GuiTextureProperties;
 import net.minecraft.client.render.texture.meta.gui.GuiTexturePropertiesAdapter;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
 import java.io.InputStream;
 import java.util.HashMap;
 import java.util.Map;
 
 public class TextureMetaHandler {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private static final Gson GSON;
     static {
         GsonBuilder builder = new GsonBuilder();
@@ -35,19 +38,15 @@ public class TextureMetaHandler {
         cachedData.clear();
     }
 
-    public void loadFromStream(InputStream stream) {
+    public void loadFromStream(InputStream stream) throws JsonParseException {
         String jsonString;
         try {
             jsonString = StringUtils.readInputString(stream);
         } catch (Exception e) {
-            e.printStackTrace();
+            LOGGER.error("Failed to read json string from stream!", e);
             return;
         }
-        try {
-            metaJson = JsonParser.parseString(jsonString).getAsJsonObject();
-        } catch (JsonParseException e) { // TODO, replace with proper non-fatal error logging
-            e.printStackTrace();
-        }
+        metaJson = JsonParser.parseString(jsonString).getAsJsonObject();
     }
 
     public boolean has(String key) {
diff --git a/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java b/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
index f8c9aa240..5a1913d90 100644
--- a/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
+++ b/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
@@ -3,7 +3,6 @@ package net.minecraft.client.render.texture.stitcher;
 import java.awt.AlphaComposite;
 import java.awt.Graphics2D;
 import java.awt.image.BufferedImage;
-import java.io.IOException;
 import java.io.InputStream;
 import java.util.ArrayList;
 import java.util.Collections;
@@ -16,6 +15,7 @@ import java.util.concurrent.ExecutorService;
 import java.util.concurrent.Executors;
 import java.util.concurrent.Future;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.texturepack.TexturePack;
@@ -25,8 +25,10 @@ import org.jetbrains.annotations.Nullable;
 
 import net.minecraft.client.render.customatlas.CustomAtlasHandler;
 import net.minecraft.client.util.helper.Textures;
+import org.slf4j.Logger;
 
 public class AtlasStitcher extends Texture {
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static final String rootAssetPath = "/assets";
     public Map<NamespaceID, IconCoordinate> textureMap = new HashMap<>();
     public BufferedImage atlas;
@@ -71,11 +73,11 @@ public class AtlasStitcher extends Texture {
             try {
                 f.get();
             } catch (InterruptedException | ExecutionException e) {
-                e.printStackTrace();
+                LOGGER.error("", e);
             }
         }
         service.shutdown();
-        System.out.println("Took '" + (System.nanoTime() - startTime)/1_000_000_000d + "' seconds to load images.");
+        LOGGER.debug("Took '{}' seconds to load images.", (System.nanoTime() - startTime) / 1_000_000_000d);
     }
 
     @Override
@@ -156,7 +158,7 @@ public class AtlasStitcher extends Texture {
             this.defaultTexture = defaultTexture;
         }
         @Override
-        public IconCoordinate call() throws Exception {
+        public IconCoordinate call() {
             coordinate.resetMetadata();
             BufferedImage image = CustomAtlasHandler.getTextureOverride(mc.texturePackList, coordinate.sourceImage);
             if(image == null) {
@@ -166,10 +168,8 @@ public class AtlasStitcher extends Texture {
                         try {
                             image = Textures.readImageUnhandled(pack.getResourceAsStream(coordinate.sourceImage));
                             if (image != null) break;
-                        } catch (IOException io) {
-                            io.printStackTrace();
                         } catch (Exception e) {
-                            e.printStackTrace();
+                            LOGGER.error("", e);
                         }
                     }
                     String metaPath = coordinate.sourceImage + ".mcmeta";
@@ -177,14 +177,14 @@ public class AtlasStitcher extends Texture {
                         try (InputStream stream = pack.getResourceAsStream(metaPath)){
                             coordinate.initMetadata(stream);
                         } catch (Exception e) {
-                            e.printStackTrace();
+                            LOGGER.error("Failed to initiate metadata for '{}'!", coordinate.namespaceId, e);
                         }
                     }
                 }
 
             }
             if (image == null || image == Textures.missingTexture){
-                System.out.println(coordinate.sourceImage + " could not be found!");
+                LOGGER.warn("{} could not be found!", coordinate.sourceImage);
                 if (defaultTexture != null){
                     image = Textures.readImage(mc.texturePackList.getResourceAsStream(defaultTexture));
                 }
diff --git a/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java b/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
index d135a867f..7f70fb9d0 100644
--- a/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
+++ b/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
@@ -1,15 +1,18 @@
 package net.minecraft.client.render.texture.stitcher;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.texture.meta.TextureMetaHandler;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
 import java.awt.*;
 import java.awt.image.BufferedImage;
 import java.io.InputStream;
 
 public class IconCoordinate implements Comparable<IconCoordinate> {
+    private static final Logger LOGGER = LogUtils.getLogger();
     public int iconX;
     public int iconY;
     public int width;
@@ -103,7 +106,11 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
     }
 
     protected void initMetadata(InputStream stream) {
-        metaHandler.loadFromStream(stream);
+        try {
+            metaHandler.loadFromStream(stream);
+        } catch (Exception e) {
+            LOGGER.error("Failed to load metadata for '{}'!", namespaceId, e);
+        }
     }
 
     public boolean hasMeta(String key) {
diff --git a/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java b/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
index 070eee5f0..d1da1f01c 100644
--- a/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
+++ b/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
@@ -2,9 +2,11 @@ package net.minecraft.client.render.texture.stitcher;
 
 
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
 
 import java.io.IOException;
 import java.net.URI;
@@ -23,6 +25,7 @@ import java.util.Objects;
 import java.util.stream.Stream;
 
 public class TextureRegistry {
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static HashMap<String, AtlasStitcher> stitcherMap = new HashMap<>();
     @SuppressWarnings("unused")
     public static AtlasStitcher blockAtlas = register("block", new AtlasStitcher("textures/block", false, true, "/assets/minecraft/textures/block/texture_missing.png"));
@@ -86,8 +89,7 @@ public class TextureRegistry {
                 initializeAllFiles("minecraft", stitcher, stitcher != artAtlas);
             }
         } catch (Exception e) {
-            new RuntimeException(e).printStackTrace();
-            System.out.println("Failed to fully initialize assets, some issue may occur!");
+            LOGGER.warn("Failed to fully initialize assets, some issue may occur!", e);
         }
     }
 
@@ -117,7 +119,7 @@ public class TextureRegistry {
         try {
             uri = Objects.requireNonNull(TextureRegistry.class.getResource(directory)).toURI();
         } catch (NullPointerException npe) {
-            System.out.println("Failed to load directory '" + directory + "'! Skipping!");
+            LOGGER.warn("Failed to load directory '{}'! Skipping!", directory);
             return new String[0];
         }
 
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
index 033205367..46d80c445 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.texturepack;
 import java.io.IOException;
 import java.io.InputStream;
 import java.net.URI;
+import java.net.URL;
 import java.nio.file.*;
 import java.util.ArrayList;
 import java.util.Collections;
@@ -10,9 +11,12 @@ import java.util.Iterator;
 import java.util.List;
 import java.util.stream.Stream;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import org.slf4j.Logger;
 
 public abstract class TexturePack {
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public String packId;
 	public String fileName;
 	public ManifestBase manifest;
@@ -50,9 +54,11 @@ public abstract class TexturePack {
 
 		if (!directory.endsWith("/")) directory = directory + "/";
 
-		try
+		label: try
 		{
-			URI uri = TexturePack.class.getResource(directory).toURI();
+			URL url = TexturePack.class.getResource(directory);
+			if (url == null) break label;
+			URI uri = url.toURI();
 			Path myPath;
 			FileSystem fileSystem = null;
 			if (uri.getScheme().equals("jar"))
@@ -87,7 +93,7 @@ public abstract class TexturePack {
 		}
 		catch (Exception e)
 		{
-			e.printStackTrace();
+            LOGGER.error("Exception while loading all files in directory '{}' at '{}'!", directory, packId, e);
 		}
 
 		return paths.toArray(new String[0]);
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
index 6fe225e61..aa7b7a23c 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
@@ -3,7 +3,6 @@ package net.minecraft.client.render.texturepack;
 import java.awt.image.BufferedImage;
 import java.io.BufferedReader;
 import java.io.File;
-import java.io.FileInputStream;
 import java.io.IOException;
 import java.io.InputStream;
 import java.io.InputStreamReader;
@@ -14,18 +13,22 @@ import java.util.List;
 import java.util.zip.ZipEntry;
 import java.util.zip.ZipFile;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texture.BufferedTexture;
 import net.minecraft.client.render.texturepack.Manifest.ManifestException;
+import org.slf4j.Logger;
 
 import javax.imageio.ImageIO;
 
 public class TexturePackCustom extends TexturePack
 {
+	private static final Logger LOGGER = LogUtils.getLogger();
 	private BufferedTexture thumbnailImage;
 	private BufferedImage thumbnailBuffer;
 	public final File file;
 	private ZipFile zipFile;
+	public boolean debug = false;
 
     public TexturePackCustom(File file)
     {
@@ -34,6 +37,10 @@ public class TexturePackCustom extends TexturePack
         this.file = file;
     }
 
+	public void setDebug() {
+		debug = true;
+	}
+
 	@Override
 	public void readTexturePackManifest()
 		throws IOException {
@@ -42,21 +49,14 @@ public class TexturePackCustom extends TexturePack
 			ZipEntry manifestEntry = zipFile.getEntry("manifest.json");
 			if(manifestEntry != null) {
 				// manifest.json exists
-				
-				InputStream in = null;
-				try {
-					in = zipFile.getInputStream(manifestEntry);
-					readManifest(in);
-				}catch (Exception e) {
-					// TODO
-					e.printStackTrace();
-				}finally {
-					try {
-						in.close();
-					}catch (Exception e) {}
-				}
+
+                try (InputStream in = zipFile.getInputStream(manifestEntry)) {
+                    readManifest(in);
+                } catch (Exception e) {
+                    LOGGER.error("Exception reading manifest for '{}'!", packId, e);
+                }
 			}else {
-				// Assume its an old texture pack
+				// Assume it's an old texture pack
 
 				String name = file.getName();
 				String line1 = "";
@@ -64,25 +64,12 @@ public class TexturePackCustom extends TexturePack
 				
 				ZipEntry packTxtEntry = zipFile.getEntry("pack.txt");
 				if(packTxtEntry != null) {
-					InputStream in = null;
-					BufferedReader br = null;
-					try {
-						in = zipFile.getInputStream(packTxtEntry);
-						br = new BufferedReader(new InputStreamReader(in));
-
-						line1 = br.readLine();
-						line2 = br.readLine();
-					}catch (Exception e) {
-						// TODO
-						e.printStackTrace();
-					}finally {
-						try {
-							in.close();
-						}catch (Exception e) {}
-						try {
-							br.close();
-						}catch (Exception e) {}
-					}
+                    try (InputStream in = zipFile.getInputStream(packTxtEntry); BufferedReader br = new BufferedReader(new InputStreamReader(in))) {
+                        line1 = br.readLine();
+                        line2 = br.readLine();
+                    } catch (Exception e) {
+                        LOGGER.error("Exception reading pack.txt for '{}'!", packId, e);
+                    }
 				}
 				
 				this.manifest = new ManifestFallback(name, line1, line2, 0);
@@ -90,18 +77,11 @@ public class TexturePackCustom extends TexturePack
 		} else if (file.isDirectory()) {
 			File manifestFile = new File(this.file, "manifest.json");
 			if(manifestFile.exists()) {
-				InputStream in = null;
-				try {
-					in = new FileInputStream(manifestFile);
-					readManifest(in);
-				}catch (Exception e) {
-					// TODO
-					e.printStackTrace();
-				}finally {
-					try {
-						in.close();
-					}catch (Exception e) {}
-				}
+                try (InputStream in = Files.newInputStream(manifestFile.toPath())) {
+                    readManifest(in);
+                } catch (Exception e) {
+                    LOGGER.error("Exception reading manifest for '{}'!", packId, e);
+                }
 			}else {
 				// Assume its an old texture pack
 
@@ -111,25 +91,12 @@ public class TexturePackCustom extends TexturePack
 				
 				File packTxtFile = new File(this.file, "pack.txt");
 				if(packTxtFile.exists()) {
-					InputStream in = null;
-					BufferedReader br = null;
-					try {
-						in = new FileInputStream(packTxtFile);
-						br = new BufferedReader(new InputStreamReader(in));
-
-						line1 = br.readLine();
-						line2 = br.readLine();
-					}catch (Exception e) {
-						// TODO
-						e.printStackTrace();
-					}finally {
-						try {
-							in.close();
-						}catch (Exception e) {}
-						try {
-							br.close();
-						}catch (Exception e) {}
-					}
+                    try (InputStream in = Files.newInputStream(packTxtFile.toPath()); BufferedReader br = new BufferedReader(new InputStreamReader(in))) {
+                        line1 = br.readLine();
+                        line2 = br.readLine();
+                    } catch (Exception e) {
+                        LOGGER.error("Exception reading pack.txt for '{}'!", packId, e);
+                    }
 				}
 				
 				this.manifest = new ManifestFallback(name, line1, line2, 0);
@@ -160,10 +127,10 @@ public class TexturePackCustom extends TexturePack
 			this.manifest = new Manifest(file, in);
 		}catch (ManifestException e) {
 			this.manifest = new ManifestFallback(fileName, "Manifest Error: " + e.getMessage(), "", -1);
-			e.printStackTrace();
+			LOGGER.error("Manifest Error!", e);
 		}catch (Exception e) {
 			this.manifest = new ManifestFallback(fileName, "Manifest Error", "", -1);
-			e.printStackTrace();
+			LOGGER.error("Manifest Error!", e);
 		}
 	}
 
@@ -183,14 +150,14 @@ public class TexturePackCustom extends TexturePack
     {
         if(thumbnailBuffer != null && thumbnailImage == null)
         {
-            thumbnailImage = minecraft.renderEngine.loadBufferedTexture(thumbnailBuffer);
+            thumbnailImage = minecraft.textureManager.loadBufferedTexture(thumbnailBuffer);
         }
         if(thumbnailBuffer != null)
         {
-            minecraft.renderEngine.bindTexture(thumbnailImage);
+            minecraft.textureManager.bindTexture(thumbnailImage);
         } else
         {
-			minecraft.renderEngine.loadTexture("/assets/minecraft/textures/gui/unknown_pack.png").bind();
+			minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/unknown_pack.png").bind();
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
index 8954c1e4a..b2f11687e 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackDefault.java
@@ -6,11 +6,14 @@ import java.io.InputStream;
 
 import javax.imageio.ImageIO;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texture.BufferedTexture;
+import org.slf4j.Logger;
 
 public class TexturePackDefault extends TexturePack
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private BufferedTexture texturePackThumbnailTexture;
     private BufferedImage texturePackThumbnail;
 
@@ -23,9 +26,9 @@ public class TexturePackDefault extends TexturePack
         {
             texturePackThumbnail = ImageIO.read(TexturePackDefault.class.getResource("/pack.png"));
         }
-        catch(IOException ioexception)
+        catch(IOException e)
         {
-            ioexception.printStackTrace();
+            LOGGER.error("Failed to read thumbnail for '{}'!", packId, e);
         }
     }
 
@@ -43,15 +46,15 @@ public class TexturePackDefault extends TexturePack
     {
         if(texturePackThumbnail != null && texturePackThumbnailTexture == null)
         {
-            texturePackThumbnailTexture = minecraft.renderEngine.loadBufferedTexture(texturePackThumbnail);
+            texturePackThumbnailTexture = minecraft.textureManager.loadBufferedTexture(texturePackThumbnail);
         }
         if(texturePackThumbnail != null)
         {
-            minecraft.renderEngine.bindTexture(texturePackThumbnailTexture);
+            minecraft.textureManager.bindTexture(texturePackThumbnailTexture);
         }
         else
         {
-            minecraft.renderEngine.loadTexture("/assets/minecraft/textures/gui/unknown_pack.png").bind();
+            minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/unknown_pack.png").bind();
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index 1d5b68f9d..ae6498673 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -1,20 +1,24 @@
 package net.minecraft.client.render.texturepack;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.sound.SoundRepository;
 import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
 import java.io.File;
 import java.io.IOException;
 import java.io.InputStream;
 import java.util.ArrayList;
+import java.util.Arrays;
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
 public class TexturePackList
 {
+	private static final Logger LOGGER = LogUtils.getLogger();
 	private static final String SEPERATOR = "<-=-=->";
     private List<TexturePack> availableTexturePacks = new ArrayList<>();
     private final TexturePack defaultTexturePack = new TexturePackDefault();
@@ -84,13 +88,13 @@ public class TexturePackList
 		}
 	}
 	public void refresh(){
-		mc.renderEngine.refreshTexturesAndDisplayErrors();
-		mc.fontRenderer = new FontRenderer(mc, mc.gameSettings, "/font/default.png", mc.renderEngine);
+		mc.textureManager.refreshTexturesAndDisplayErrors();
+		mc.font = new Font(mc, mc.gameSettings, mc.textureManager);
 		mc.renderGlobal.loadRenderers();
 		if (mc.currentScreen != null) {
-			mc.currentScreen.refreshFontRenderer();
+			mc.currentScreen.updateFont();
 		}
-		mc.renderEngine.updateDynamicTextures(false);
+		mc.textureManager.updateDynamicTextures(false);
 		SoundRepository.reload();
 	}
 
@@ -100,31 +104,29 @@ public class TexturePackList
 		boolean update = false;
 		
 		if(texturePackDir.exists() && texturePackDir.isDirectory()) {
-			File[] filesInDir = texturePackDir.listFiles();
-			
-			if(filesInDir != null) {
+			File[] filesArr = texturePackDir.listFiles();
+
+			if(filesArr != null) {
+                List<File> fileList = new ArrayList<>(Arrays.asList(filesArr));
 				if (mc.gameSettings.enableDevResourceLoading.value) { // Load project resources as an available texture pack
-					File[] tempList = new File[filesInDir.length + 1];
-					for (int i = 0; i < tempList.length; i++) {
-						if (i < tempList.length - 1){
-							tempList[i] = filesInDir[i];
-						} else {
-							File local = new File("./src/main/resources");
-							System.out.println(local.getAbsoluteFile());
-							tempList[i] = local;
-						}
+					File resources = new File("./src/main/resources");
+					fileList.add(resources);
+
+					File devPacksPath = new File("./devPacks");
+					File[] devPacks = devPacksPath.listFiles();
+					if (devPacks != null) {
+                        fileList.addAll(Arrays.asList(devPacks));
 					}
-					filesInDir = tempList;
 				}
 
-				for(File file : filesInDir) {
+				for(File file : fileList) {
 					if(!isTexturePack(file)) {
 						continue;
 					}
 					String id = getTexturePackID(file);
 					try {
 						if(!texturePackIDs.containsKey(id)) {
-							TexturePack pack = new TexturePackCustom(file);
+							TexturePackCustom pack = new TexturePackCustom(file);
 							pack.packId = id;
 							pack.readZipFile();
 							pack.readTexturePackManifest();
@@ -137,7 +139,7 @@ public class TexturePackList
 						TexturePack pack = texturePackIDs.get(id);
 						currentTexturePacks.add(pack);
 					}catch (IOException e) {
-						e.printStackTrace();
+                        LOGGER.error("Failed to make texturepack for file '{}'!", file.getPath(), e);
 					}
 				}
 			}
@@ -145,7 +147,7 @@ public class TexturePackList
 		List<TexturePack> previousTexturePacks = this.availableTexturePacks;
 		previousTexturePacks.removeAll(currentTexturePacks);
 		
-		if(previousTexturePacks.size() > 0) {
+		if(!previousTexturePacks.isEmpty()) {
 			update = true;
 		}
 		
diff --git a/src/main/java/net/minecraft/client/sound/CodecMus.java b/src/main/java/net/minecraft/client/sound/CodecMus.java
index 66b9cd587..7a205306b 100644
--- a/src/main/java/net/minecraft/client/sound/CodecMus.java
+++ b/src/main/java/net/minecraft/client/sound/CodecMus.java
@@ -4,20 +4,19 @@ import java.io.IOException;
 import java.io.InputStream;
 import java.net.URL;
 
+import com.mojang.logging.LogUtils;
 import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
 import paulscode.sound.codecs.CodecJOrbis;
 
-// Referenced classes of package net.minecraft.src:
-//            DecoderInputStream
-
 public class CodecMus extends CodecJOrbis {
-
+    private static final Logger LOGGER = LogUtils.getLogger();
     @Override
 	protected InputStream openInputStream() {
         try {
             return new DecoderInputStream(url, urlConnection.getInputStream());
         } catch (IOException e) {
-            e.printStackTrace();
+            LOGGER.error("Exception decoding stream '{}'!", url.getPath(), e);
             return null;
         }
     }
@@ -51,17 +50,17 @@ public class CodecMus extends CodecJOrbis {
         }
 
         @Override
-        public int read(byte abyte0[], int i, int j)
+        public int read(byte @NotNull [] b, int i, int j)
         {
             try {
-                j = inputStream.read(abyte0, i, j);
+                j = inputStream.read(b, i, j);
             } catch (IOException e) {
-                e.printStackTrace();
+                LOGGER.error("CodecMus data read error!", e);
                 return 0;
             }
             for(int k = 0; k < j; k++)
             {
-                byte byte0 = abyte0[i + k] ^= hash >> 8;
+                byte byte0 = b[i + k] ^= hash >> 8;
                 hash = hash * 0x1dba038f + 0x14ee3 * byte0;
             }
 
